<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>homework18_optional_clone_object</title>
</head>

<body>
  <script>
    'use strict';

    const obj = {
      $number: 5,
      $string: 'text',
      $boolean: false,
      $nan: NaN,
      $array: [1, 2, 3, 'a'],
      $null: null,
      $undefined: undefined,
      $object: {
        $number1: 5,
        $string1: 'text',
        $boolean1: false,
        $nan1: NaN,
        $array1: [1, 2, 3, 4],
        $null1: null,
        $undefined1: undefined,
        $object1: {
          $number2: 5,
          $string2: 'text',
          $boolean2: false,
          $nan2: NaN,
          $array2: [1, 2, 3, 4],
          $null2: null,
          $undefined2: undefined,
          $object2: {
            $array3: [1, 2, 3, 4],
          },
        },
      },
    }

    function copyArray(array) {
      const tempArray = [];
      for (let i = 0; i < array.length; i++) {
        tempArray[i] = array[i];
      }
      return tempArray;
    }

    function copyObj(obj) {
      const tempObj = {};
      for (let key in obj) {
        //console.log(key, obj[key]);
        if (typeof obj[key] === 'object' && obj[key] !== null) {
          if (Array.isArray(obj[key])) {
            tempObj[key] = copyArray(obj[key]);
          } else {
            tempObj[key] = copyObj(obj[key]);
          }
        } else {
          tempObj[key] = obj[key];
        }
      }
      return tempObj;
    }

    const newObj = copyObj(obj);

    console.log(newObj);

  </script>
</body>

</html>